Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3679)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3681)
@@ -5009,5 +5228,19 @@
           IF ( bc_dirichlet_s )  THEN
 
-             CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
+             CALL pmci_interp_1sto_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
+                                       r1yv, r2yv, r1zo, r2zo,                 &
+                                       logc_v_s, logc_ratio_v_s,               &
+                                       logc_kbounds_v_s, nzt_topo_nestbc_s,    &
+                                       kcto, iflo, ifuo, jflv, jfuv, kflo,     &
+                                       kfuo, ijkfc_v, 's', 'v' )
+
+             CALL pmci_interp_1sto_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
+                                       r1yo, r2yo, r1zw, r2zw,                 &
+                                       logc_w_s, logc_ratio_w_s,               &
+                                       logc_kbounds_w_s, nzt_topo_nestbc_s,    &
+                                       kctw, iflo, ifuo, jflo, jfuo, kflw,     &
+                                       kfuw, ijkfc_w, 's','w' )
+
+             CALL pmci_interp_1sto_sn( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
                                        r1yo, r2yo, r1zo, r2zo,                 &
                                        logc_u_s, logc_ratio_u_s,               &
@@ -5016,22 +5249,8 @@
                                        kfuo, ijkfc_u, 's', 'u' )
 
-             CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
-                                       r1yv, r2yv, r1zo, r2zo,                 &
-                                       logc_v_s, logc_ratio_v_s,               &
-                                       logc_kbounds_v_s, nzt_topo_nestbc_s,    &
-                                       kcto, iflo, ifuo, jflv, jfuv, kflo,     &
-                                       kfuo, ijkfc_v, 's', 'v' )
-
-             CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zw, r2zw,                 &
-                                       logc_w_s, logc_ratio_w_s,               &
-                                       logc_kbounds_w_s, nzt_topo_nestbc_s,    &
-                                       kctw, iflo, ifuo, jflo, jfuo, kflw,     &
-                                       kfuw, ijkfc_w, 's','w' )
-
              IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   &
                   (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
                      .NOT. constant_diffusion ) )  THEN
-!                CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
+!                CALL pmci_interp_1sto_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
 !                                          r1yo, r2yo, r1zo, r2zo,              &
 !                                          logc_w_s, logc_ratio_w_s,            &
@@ -5047,5 +5266,5 @@
 
              IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
-                CALL pmci_interp_tril_sn( diss, dissc,  ico, jco, kco, r1xo,   &
+                CALL pmci_interp_1sto_sn( diss, dissc,  ico, jco, kco, r1xo,   &
                                           r2xo, r1yo, r2yo, r1zo, r2zo,        &
                                           logc_w_s, logc_ratio_w_s,            &
@@ -5056,5 +5275,5 @@
 
              IF ( .NOT. neutral )  THEN
-                CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
+                CALL pmci_interp_1sto_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_s, logc_ratio_w_s,            &
@@ -5065,5 +5284,5 @@
 
              IF ( humidity )  THEN
-                CALL pmci_interp_tril_sn( q, q_c, ico, jco, kco, r1xo, r2xo,   &
+                CALL pmci_interp_1sto_sn( q, q_c, ico, jco, kco, r1xo, r2xo,   &
                                           r1yo,r2yo, r1zo, r2zo,               &
                                           logc_w_s, logc_ratio_w_s,            &
@@ -5074,5 +5293,5 @@
                 IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
-                   CALL pmci_interp_tril_sn( qc, qcc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_sn( qc, qcc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo,r2yo, r1zo, r2zo,      &
                                              logc_w_s, logc_ratio_w_s,         &
@@ -5082,5 +5301,5 @@
                                              kflo, kfuo, ijkfc_s, 's', 's' )
 
-                   CALL pmci_interp_tril_sn( nc, ncc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_sn( nc, ncc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo,r2yo, r1zo, r2zo,      &
                                              logc_w_s, logc_ratio_w_s,         &
@@ -5094,5 +5313,5 @@
                 IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 
-                   CALL pmci_interp_tril_sn( qr, qrc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_sn( qr, qrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo,r2yo, r1zo, r2zo,      &
                                              logc_w_s, logc_ratio_w_s,         &
@@ -5102,5 +5321,5 @@
                                              kflo, kfuo, ijkfc_s, 's', 's' )
 
-                   CALL pmci_interp_tril_sn( nr, nrc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_sn( nr, nrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo,r2yo, r1zo, r2zo,      &
                                              logc_w_s, logc_ratio_w_s,         &
@@ -5115,5 +5334,5 @@
 
              IF ( passive_scalar )  THEN
-                CALL pmci_interp_tril_sn( s, sc, ico, jco, kco, r1xo, r2xo,    &
+                CALL pmci_interp_1sto_sn( s, sc, ico, jco, kco, r1xo, r2xo,    &
                                           r1yo,r2yo, r1zo, r2zo,               &
                                           logc_w_s, logc_ratio_w_s,            &
@@ -5126,5 +5345,5 @@
              IF ( air_chemistry  .AND.  nest_chemistry )  THEN
                 DO  n = 1, nspec
-                   CALL pmci_interp_tril_sn( chem_species(n)%conc,             &
+                   CALL pmci_interp_1sto_sn( chem_species(n)%conc,             &
                                              chem_spec_c(:,:,:,n),             &
                                              ico, jco, kco, r1xo, r2xo,        &
@@ -5142,5 +5361,5 @@
           IF ( bc_dirichlet_n )  THEN
              
-             CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
+             CALL pmci_interp_1sto_sn( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
                                        r1yo, r2yo, r1zo, r2zo,                 &
                                        logc_u_n, logc_ratio_u_n,               &
@@ -5149,5 +5368,5 @@
                                        kfuo, ijkfc_u, 'n', 'u' )
 
-             CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
+             CALL pmci_interp_1sto_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
                                        r1yv, r2yv, r1zo, r2zo,                 &
                                        logc_v_n, logc_ratio_v_n,               &
@@ -5156,5 +5375,5 @@
                                        kfuo, ijkfc_v, 'n', 'v' )
 
-             CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
+             CALL pmci_interp_1sto_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
                                        r1yo, r2yo, r1zw, r2zw,                 &
                                        logc_w_n, logc_ratio_w_n,               &
@@ -5166,5 +5385,5 @@
                   (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
                      .NOT. constant_diffusion ) )  THEN
-!                CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
+!                CALL pmci_interp_1sto_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
 !                                          r1yo, r2yo, r1zo, r2zo,              &
 !                                          logc_w_n, logc_ratio_w_n,            &
@@ -5180,5 +5399,5 @@
 
              IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
-                CALL pmci_interp_tril_sn( diss, dissc,  ico, jco, kco, r1xo,   &
+                CALL pmci_interp_1sto_sn( diss, dissc,  ico, jco, kco, r1xo,   &
                                           r2xo, r1yo, r2yo, r1zo, r2zo,        &
                                           logc_w_n, logc_ratio_w_n,            &
@@ -5190,5 +5409,5 @@
 
              IF ( .NOT. neutral )  THEN
-                CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
+                CALL pmci_interp_1sto_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_n, logc_ratio_w_n,            &
@@ -5199,5 +5418,5 @@
 
              IF ( humidity )  THEN
-                CALL pmci_interp_tril_sn( q, q_c, ico, jco, kco, r1xo, r2xo,   &
+                CALL pmci_interp_1sto_sn( q, q_c, ico, jco, kco, r1xo, r2xo,   &
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_n, logc_ratio_w_n,            &
@@ -5208,5 +5427,5 @@
                 IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
-                   CALL pmci_interp_tril_sn( qc, qcc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_sn( qc, qcc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_n, logc_ratio_w_n,         &
@@ -5216,5 +5435,5 @@
                                              kflo, kfuo, ijkfc_s, 'n', 's' )
 
-                   CALL pmci_interp_tril_sn( nc, ncc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_sn( nc, ncc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_u_n, logc_ratio_u_n,         &
@@ -5228,5 +5447,5 @@
                 IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 
-                   CALL pmci_interp_tril_sn( qr, qrc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_sn( qr, qrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_n, logc_ratio_w_n,         &
@@ -5236,5 +5455,5 @@
                                              kflo, kfuo, ijkfc_s, 'n', 's' )
 
-                   CALL pmci_interp_tril_sn( nr, nrc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_sn( nr, nrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_n, logc_ratio_w_n,         &
@@ -5249,5 +5468,5 @@
 
              IF ( passive_scalar )  THEN
-                CALL pmci_interp_tril_sn( s, sc, ico, jco, kco, r1xo, r2xo,    &
+                CALL pmci_interp_1sto_sn( s, sc, ico, jco, kco, r1xo, r2xo,    &
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_n, logc_ratio_w_n,            &
@@ -5260,5 +5479,5 @@
              IF ( air_chemistry  .AND.  nest_chemistry )  THEN
                 DO  n = 1, nspec
-                   CALL pmci_interp_tril_sn( chem_species(n)%conc,             &
+                   CALL pmci_interp_1sto_sn( chem_species(n)%conc,             &
                                              chem_spec_c(:,:,:,n),             &
                                              ico, jco, kco, r1xo, r2xo,        &
@@ -5276,18 +5495,19 @@
 !
 !--    All PEs are top-border PEs
-       CALL pmci_interp_tril_t( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,      &
+       CALL pmci_interp_1sto_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,      &
+                                r2yo, r1zw, r2zw, kctw, iflo, ifuo,            &
+                                jflo, jfuo, kflw, kfuw, ijkfc_w, 'w' )
+       CALL pmci_interp_1sto_t( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,      &
                                 r2yo, r1zo, r2zo, kcto, iflu, ifuu,            &
                                 jflo, jfuo, kflo, kfuo, ijkfc_u, 'u' )
-       CALL pmci_interp_tril_t( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,      &
+       CALL pmci_interp_1sto_t( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,      &
                                 r2yv, r1zo, r2zo, kcto, iflo, ifuo,            &
                                 jflv, jfuv, kflo, kfuo, ijkfc_v, 'v' )
-       CALL pmci_interp_tril_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,      &
-                                r2yo, r1zw, r2zw, kctw, iflo, ifuo,            &
-                                jflo, jfuo, kflw, kfuw, ijkfc_w, 'w' )
+
 
        IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.         &
             (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.          &
                .NOT. constant_diffusion ) )  THEN
-!          CALL pmci_interp_tril_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,   &
+!          CALL pmci_interp_1sto_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,   &
 !                                   r2yo, r1zo, r2zo, kcto, iflo, ifuo,         &
 !                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 'e' )
@@ -5299,5 +5519,5 @@
 
        IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
-          CALL pmci_interp_tril_t( diss, dissc, ico, jco, kco, r1xo, r2xo,     &
+          CALL pmci_interp_1sto_t( diss, dissc, ico, jco, kco, r1xo, r2xo,     &
                                    r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,   &
                                    jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
@@ -5305,5 +5525,5 @@
 
        IF ( .NOT. neutral )  THEN
-          CALL pmci_interp_tril_t( pt, ptc, ico, jco, kco, r1xo, r2xo,         &
+          CALL pmci_interp_1sto_t( pt, ptc, ico, jco, kco, r1xo, r2xo,         &
                                    r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,   &
                                    jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
@@ -5312,5 +5532,5 @@
        IF ( humidity )  THEN
 
-          CALL pmci_interp_tril_t( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo,    &
+          CALL pmci_interp_1sto_t( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo,    &
                                    r2yo, r1zo, r2zo, kcto, iflo, ifuo,         &
                                    jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
@@ -5318,9 +5538,9 @@
           IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
-             CALL pmci_interp_tril_t( qc, qcc, ico, jco, kco, r1xo, r2xo, r1yo,&
+             CALL pmci_interp_1sto_t( qc, qcc, ico, jco, kco, r1xo, r2xo, r1yo,&
                                       r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
                                       jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
 
-             CALL pmci_interp_tril_t( nc, ncc, ico, jco, kco, r1xo, r2xo, r1yo,&
+             CALL pmci_interp_1sto_t( nc, ncc, ico, jco, kco, r1xo, r2xo, r1yo,&
                                       r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
                                       jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
@@ -5331,9 +5551,9 @@
 
 
-             CALL pmci_interp_tril_t( qr, qrc, ico, jco, kco, r1xo, r2xo, r1yo,&
+             CALL pmci_interp_1sto_t( qr, qrc, ico, jco, kco, r1xo, r2xo, r1yo,&
                                       r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
                                       jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
 
-             CALL pmci_interp_tril_t( nr, nrc, ico, jco, kco, r1xo, r2xo, r1yo,&
+             CALL pmci_interp_1sto_t( nr, nrc, ico, jco, kco, r1xo, r2xo, r1yo,&
                                       r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
                                       jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
@@ -5344,5 +5564,5 @@
 
        IF ( passive_scalar )  THEN
-          CALL pmci_interp_tril_t( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,     &
+          CALL pmci_interp_1sto_t( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,     &
                                    r2yo, r1zo, r2zo, kcto, iflo, ifuo,         &
                                    jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
@@ -5351,5 +5571,5 @@
        IF ( air_chemistry  .AND.  nest_chemistry )  THEN
           DO  n = 1, nspec
-             CALL pmci_interp_tril_t( chem_species(n)%conc,                    &
+             CALL pmci_interp_1sto_t( chem_species(n)%conc,                    &
                                       chem_spec_c(:,:,:,n),                    &
                                       ico, jco, kco, r1xo, r2xo,               &
@@ -5444,5 +5664,5 @@
 
 
-   SUBROUTINE pmci_interp_tril_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
+   SUBROUTINE pmci_interp_1sto_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
                                    r2z, logc, logc_ratio, logc_kbounds,        &
                                    nzt_topo_nestbc,                            &
@@ -5464,14 +5684,23 @@
       REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nys:nyn),          &
                                       INTENT(IN)    ::  logc_ratio   !<
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x     !<
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r2x     !<
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r1y     !<
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r2y     !<
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z     !<
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z     !<
+!AH      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x     !<
+!AH      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r2x     !<
+!AH      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r1y     !<
+!AH      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r2y     !<
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r1x     !<
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r2x     !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r1y     !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r2y     !<
+
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z     !<
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z     !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r1z     !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r2z     !<
       
-      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)           ::  ic     !<
-      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc     !<
-      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc     !<
+
+      INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)         ::  ic     !<
+      INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)         ::  jc     !<
+!AH      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc     !<
+      INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN)        ::  kc     !<
       INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nys:nyn),                &
                                           INTENT(IN)           :: logc   !<
@@ -5479,8 +5708,16 @@
 
       INTEGER(iwp) :: kct
-      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+
+!AH
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH
+
 !AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
 !AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
@@ -5489,43 +5726,58 @@
 
 !AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-
-      CHARACTER(LEN=1), INTENT(IN) ::  edge   !<
-      CHARACTER(LEN=1), INTENT(IN) ::  var    !<
-
-      INTEGER(iwp) ::  i        !<
-      INTEGER(iwp) ::  ia       !<
-      INTEGER(iwp) ::  ib       !<
-      INTEGER(iwp) ::  ibgp     !<
-      INTEGER(iwp) ::  ijk      !<
-      INTEGER(iwp) ::  iw       !<
-      INTEGER(iwp) ::  j        !<
+!AH
+!      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+
+      CHARACTER(LEN=1), INTENT(IN) ::  edge   !< Edge symbol: 'l', 'r', 's' or 'n' 
+      CHARACTER(LEN=1), INTENT(IN) ::  var    !< Variable symbol: 'u', 'v', 'w' or 's'
+
+      INTEGER(iwp) ::  i        !< Lower bound of the running index ia
+      INTEGER(iwp) ::  ia       !< i-index running over the parent-grid cell on the boundary 
+      INTEGER(iwp) ::  iaw      !< Reduced ia-index for workarr_lr
+      INTEGER(iwp) ::  iawbc    !< iaw-index pointing to the boundary-value nodes (either 0 or igsr-1)      
+      INTEGER(iwp) ::  ibc      !< Fixed i-index pointing to the boundary-value nodes (either i or iend)
+!AH      INTEGER(iwp) ::  ibeg     !< i-index pointing to the starting point of workarr_lr in the i-direction 
+      INTEGER(iwp) ::  iend     !< Upper bound of the running index ia
+      INTEGER(iwp) ::  ierr     !< MPI error code
+      INTEGER(iwp) ::  ijk      !< Running index for all child-grid cells within the anterpolation cell
+      INTEGER(iwp) ::  iw       !< i-index for wall_flags_0
+      INTEGER(iwp) ::  j        !< Running index in the y-direction
       INTEGER(iwp) ::  jco      !<
       INTEGER(iwp) ::  jcorr    !<
       INTEGER(iwp) ::  jinc     !<
-      INTEGER(iwp) ::  jw       !<
+      INTEGER(iwp) ::  jw       !< j-index for wall_flags_0
       INTEGER(iwp) ::  j1       !<
-      INTEGER(iwp) ::  k        !<
-      INTEGER(iwp) ::  k_wall   !< vertical index of topography top
+      INTEGER(iwp) ::  k        !< Running index in the z-direction
+      INTEGER(iwp) ::  k_wall   !< Vertical index of topography top
       INTEGER(iwp) ::  kco      !<
       INTEGER(iwp) ::  kcorr    !<
+      INTEGER(iwp) ::  kw       !< k-index for wall_flags_0
       INTEGER(iwp) ::  k1       !<
-      INTEGER(iwp) ::  l        !<
-      INTEGER(iwp) ::  m        !<
-      INTEGER(iwp) ::  n        !<
-      INTEGER(iwp) ::  kbc      !<
-      INTEGER(iwp) ::  var_flag !<      
-
-      REAL(wp) ::  cellsum     !<
-      REAL(wP) ::  cellsumd    !<
-      REAL(wp) ::  fkj         !<
-      REAL(wp) ::  fkjp        !<
-      REAL(wp) ::  fkpj        !<
-      REAL(wp) ::  fkpjp       !<
-      REAL(wp) ::  fk          !<
-      REAL(wp) ::  fkp         !<
-      REAL(wp) ::  rcorr       !<
-      REAL(wp) ::  rcorr_ijk   !<
- 
+      INTEGER(iwp) ::  l        !< Parent-grid running index in the x-direction
+      INTEGER(iwp) ::  lbeg     !< l-index pointing to the starting point of workarrc_lr in the l-direction 
+      INTEGER(iwp) ::  lp1      !< l+1
+      INTEGER(iwp) ::  loff     !< l-offset needed on the right boundary to correctly refer to boundary ghost points
+      INTEGER(iwp) ::  lw       !< Reduced l-index for workarrc_lr
+      INTEGER(iwp) ::  m        !< Parent-grid running index in the y-direction
+      INTEGER(iwp) ::  mnorthv  !< Upshift by one for the upper bound of index m in case of var == 'v'
+      INTEGER(iwp) ::  mp1      !< m+1
+      INTEGER(iwp) ::  n        !< Parent-grid running index in the z-direction
+      INTEGER(iwp) ::  np1      !< n+1
+      INTEGER(iwp) ::  ntopw    !< Upshift by one for the upper bound of index n in case of var == 'w'
+      INTEGER(iwp) ::  var_flag !< Variable flag for BTEST( wall_flags_0 )
+
+      REAL(wp) ::  cellsum      !< Sum of child-grid node values over the anterpolation cell 
+      REAL(wP) ::  cellsumd     !< Sum of differences over the anterpolation cell 
+      REAL(wp) ::  fkj          !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkjp         !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkpj         !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkpjp        !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fk           !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkp          !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  rcorr        !< Average reversibility correction for the whole anterpolation cell
+      REAL(wp) ::  rcorr_ijk    !< Reversibility correction distributed to the individual child-grid nodes
+
 ! 
 !--   Check which edge is to be handled
@@ -5534,13 +5786,54 @@
 !--      For u, nxl is a ghost node, but not for the other variables
          IF ( var == 'u' )  THEN
-            i  = nxl
-            ib = nxl - 1 
+            i     = nxl
+            iend  = nxl
+            ibc   = nxl
+            iawbc = 0
+            l     = icl + 2
+            lw    = 2
+            lbeg  = icl
+            loff  = 0
          ELSE
-            i  = nxl - 1
-            ib = nxl - 2
+            i     = nxl - igsr
+            iend  = nxl - 1
+            ibc   = nxl - 1
+            iawbc = igsr-1
+            l     = icl + 1
+            lw    = 1
+            lbeg  = icl
+            loff  = 0
          ENDIF
       ELSEIF ( edge == 'r' )  THEN
-         i  = nxr + 1
-         ib = nxr + 2
+         IF ( var == 'u' )  THEN
+            i     = nxr + 1            
+            iend  = nxr + 1
+            ibc   = nxr + 1 
+            iawbc = 0
+            l     = icr - 1
+            lw    = 1
+            lbeg  = icr - 2
+            loff  = 0
+         ELSE
+            i     = nxr + 1
+            iend  = nxr + igsr
+            ibc   = nxr + 1
+            iawbc = 0
+            l     = icr - 1
+            lw    = 1
+            lbeg  = icr - 2
+            loff  = 1
+         ENDIF
+      ENDIF
+
+      IF  ( var == 'w' )  THEN
+         ntopw = 1
+      ELSE
+         ntopw = 0
+      ENDIF
+
+      IF  ( var == 'v' )  THEN
+         mnorthv = 0
+      ELSE
+         mnorthv = 1
       ENDIF
 
